/*
   This file is part of the Aulib library.
   Name: aulib.h
   Copyright (C) 2004 Silvia Pfeiffer

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: pfeiffer@pi4.informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#ifndef _AULIB_H_
#define _AULIB_H_

/*
 * If you only want to USE aulib++ you should include this 
 * header file. You do not need to include any other header.
 *
 * But if you write a new aulib++ tool you must include every
 * single header file. It makes the compilation much faster
 * and avoids dependencies between program files.
 *
 * If you add new header to the aulib++, please put the
 * include statement at the end of this file.
 *
 * $Id: aulib.h,v 1.16 1998/09/11 11:13:15 tomczyk Exp $
 */

#include "autypes.h"      // global typedefs, constants, enums etc.
#include "austruct.h"     // basic structures
#include "auformat.h"     // about known audio formats
#include "error.h"        // exception class(es)

#include "aucache.h"      // audio container
#include "audata.h"       // classes representing audio data
#include "afplayer.h"     // audio player using AF routines
#include "fft.h"          // Fast Fourier Transformation
#include "auops.h"        // some simply audio analysis functions
#include "zerocrossing.h"
#include "autocorr.h"
#include "covariance.h"
#include "amdf.h"

#include "aucut.h"        // cut detection tool
#include "bg.h"           // background extraction tool

#include "convert.h"      // converting of user input

#include "scalarType.H" // scalar-Database definitions of MoCAWB
#include "scalarFile.H"
#include "vectorType.H" // vector-Database definitions of MoCAWB
#include "vectorFile.H"
#include "rangeTableType.H" // rangeTable-Database definitions of MoCAWB
#include "rangeTableFile.H"

#endif
