/*
   This file is part of the Aulib library.
   Name: covariance.cpp
   Copyright (C) 2004 Silvia Pfeiffer

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: pfeiffer@pi4.informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#include "covariance.h"
#include "aucache.h"

using namespace std;

double AuCovariance::covariance(const AudioCache& cache,
				const int del1, const int del2) {
  int sum = 0;

  for (size_t i = del1; i < cache.size(); i++) {
    if ((((int)i-del2) < (int)cache.size()) &&
	(((int)i-del2) >= 0)) {
      sum += cache[(int)i-del1] * cache[(int)i-del2];
    }
  }

  return (double)sum/(double)cache.samplingRate();
}
