/*
   This file is part of the Aulib library.
   Name: rangeTableVectorFile.H
   Copyright (C) 2004 Silvia Pfeiffer

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: pfeiffer@pi4.informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#ifndef _RANGETABLEVECTORFILE_H
#define _RANGETABLEVECTORFILE_H


#include <iostream.h>
#include <fstream.h>
#ifndef _WIN32
#include <string>
#else
#include <bstring.h>
#endif
#include "rangeTableType.H"

class rangeTableVectorFile {
public:
  string filename;
  float minValue, maxValue;

  rangeTableVectorFile ();
  ~rangeTableVectorFile ();

  int newDB(string _filename, int _startFrameNo, int _stopFrameNo, int _size);
  int openDB(string _filename, int _startFrameNo, int _stopFrameNo, int _size=-1);
  int closeDB();
  int save(rangeTableVectorType value);
  rangeTableVectorType load(int _startFrameNo, int _stopFrameNo, int _size);

  int getSize () {return size;}

protected:
  // file handle to the DB
  // always open as long as the DB is open
  // NULL = no DB open
  // NULL != DB already open
  FILE *file;
  // film data;
  string datafilename;
  int startFrameNo, stopFrameNo;
  int size;

  // temp data
  char buffer[100];

};

#endif _RANGETABLEVECTORFILE_H
